import webpack from 'webpack';
import http from 'http';
import { UserOptions, BaseTailwindService } from 'tailwindcss-webpack-plugin-utils';

declare class DevtoolsServer {
    host: string;
    port: number;
    server: http.Server;
    service: Compiler['$tailwind'];
    _listen: boolean;
    constructor(options: UserOptions, compiler: Compiler);
    _ensureStart: () => Promise<{
        port: number;
        host: string;
    }>;
    ensureStart(): Promise<{
        port: number;
        host: string;
    }>;
    close(callback?: (err?: Error) => void): void;
}

declare class Service extends BaseTailwindService {
    constructor(options?: UserOptions);
    invalidateCssModule(): void;
}

declare type Compiler = {
    $tailwind: {
        dirty: Set<string>;
        server: DevtoolsServer;
        service: Service;
    };
} & webpack.Compiler;

declare class TailwindCSSWebpackPlugin {
    options: UserOptions;
    constructor(options?: UserOptions);
    apply(compiler: Compiler): void;
}

export { TailwindCSSWebpackPlugin };
