"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  TailwindCSSWebpackPlugin: () => TailwindCSSWebpackPlugin
});
module.exports = __toCommonJS(src_exports);
var import_webpack = require("webpack");
var import_tailwindcss_webpack_plugin_utils3 = require("tailwindcss-webpack-plugin-utils");

// src/constants.ts
var import_path = require("path");
var import_url = require("url");
var import_meta = {};
var PLUGIN_NAME = "tailwindcss-webpack-plugin";
var DEFAULT_DEVTOOLS_PORT = 9999;
var DEFAULT_DEVTOOLS_HOST = "127.0.0.1";
var PACKAGE_DIR = typeof __dirname !== "undefined" ? __dirname : (0, import_path.dirname)((0, import_url.fileURLToPath)(import_meta.url));
var COMPILE_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_compile-entry_.js"
);
var TAILWIND_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_tailwind_.css"
);
var DEVTOOLS_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_tailwind-devtools_.js"
);
var DEVTOOLS_LOADER_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./loaders/devtools-loader.js"
);
var CSS_LOADER_PATH = (0, import_path.join)(PACKAGE_DIR, "./loaders/css-loader.js");

// src/util.ts
var import_fs = require("fs");
var import_tailwindcss_webpack_plugin_utils2 = require("tailwindcss-webpack-plugin-utils");

// src/devtools/server.ts
var import_http = __toESM(require("http"));
var import_get_port_please = require("get-port-please");
var import_tailwindcss_webpack_plugin_utils = require("tailwindcss-webpack-plugin-utils");
var DevtoolsServer = class {
  constructor(options, compiler) {
    this._ensureStart = (0, import_tailwindcss_webpack_plugin_utils.promiseSingleton)(
      () => new Promise(async (resolve) => {
        this.port = await (0, import_get_port_please.getPort)(this.port);
        if (!this._listen) {
          this.server.listen(this.port, this.host, () => {
            this._listen = true;
            (0, import_tailwindcss_webpack_plugin_utils.debug)(`[devtools-server]: listen at ${this.host}:${this.port}`);
            process.on("exit", () => {
              this.close();
            });
            resolve({
              port: this.port,
              host: this.host
            });
          });
        }
      })
    );
    var _a, _b;
    this.host = ((_a = options.devtools) == null ? void 0 : _a.host) ?? DEFAULT_DEVTOOLS_HOST;
    this.port = ((_b = options.devtools) == null ? void 0 : _b.port) ?? DEFAULT_DEVTOOLS_PORT;
    this.server = import_http.default.createServer(async (req, res) => {
      const devtoolsMiddleware = (0, import_tailwindcss_webpack_plugin_utils.createDevtoolsMiddleware)(
        compiler.$tailwind.service
      );
      devtoolsMiddleware(req, res);
    });
    this.server.on("error", (err) => {
      (0, import_tailwindcss_webpack_plugin_utils.debug)(`[devtools-server]: listen err`, err);
      throw err;
    });
    this.service = compiler.$tailwind;
    this._listen = false;
  }
  async ensureStart() {
    (0, import_tailwindcss_webpack_plugin_utils.debug)(`[devtools-server]: ensure start server`);
    return this._ensureStart();
  }
  close(callback) {
    if (this._listen) {
      (0, import_tailwindcss_webpack_plugin_utils.debug)(`[devtools-server]: close`);
      this.server.close((err) => callback == null ? void 0 : callback(err));
    } else {
      callback == null ? void 0 : callback();
    }
  }
};

// src/util.ts
var Service = class extends import_tailwindcss_webpack_plugin_utils2.BaseTailwindService {
  constructor(options) {
    super(options);
  }
  invalidateCssModule() {
    var _a, _b;
    (0, import_tailwindcss_webpack_plugin_utils2.debug)(
      `invalidate virtual module ${((_a = this.options) == null ? void 0 : _a.entry) ?? TAILWIND_ENTRY_PATH}`
    );
    const fullPath = (0, import_tailwindcss_webpack_plugin_utils2.ensureAbsolute)(((_b = this.options) == null ? void 0 : _b.entry) ?? TAILWIND_ENTRY_PATH);
    const timestamp = Date.now();
    (0, import_fs.utimesSync)(fullPath, timestamp, timestamp);
  }
};
var ensureService = async (compiler, options) => {
  if (compiler.$tailwind) {
    return;
  }
  (0, import_tailwindcss_webpack_plugin_utils2.debug)(`ensure compiler.$tailwind options -> `, options);
  compiler.$tailwind = {
    dirty: /* @__PURE__ */ new Set(),
    server: new DevtoolsServer(options, compiler),
    service: new Service(options)
  };
};

// src/index.ts
var TailwindCSSWebpackPlugin = class {
  constructor(options) {
    this.options = options ?? {};
  }
  apply(compiler) {
    var _a, _b;
    compiler.options.resolve.alias = {
      [import_tailwindcss_webpack_plugin_utils3.DEVTOOLS_VIRTUAL_ID]: DEVTOOLS_ENTRY_PATH,
      [import_tailwindcss_webpack_plugin_utils3.TAILWIND_ENTRY_VIRTUAL_ID]: (0, import_tailwindcss_webpack_plugin_utils3.ensureAbsolute)(
        ((_a = this.options) == null ? void 0 : _a.entry) ?? TAILWIND_ENTRY_PATH
      ),
      ...compiler.options.resolve.alias
    };
    compiler.options.module.rules.unshift({
      enforce: "pre",
      include: (resource) => resource.includes(import_tailwindcss_webpack_plugin_utils3.TAILWIND_ENTRY_VIRTUAL_ID) || /\.css$/.test(resource) && !/node_modules/.test(resource),
      loader: CSS_LOADER_PATH
    });
    compiler.options.module.rules.unshift({
      enforce: "pre",
      include: (resource) => resource.includes(import_tailwindcss_webpack_plugin_utils3.DEVTOOLS_VIRTUAL_ID),
      loader: DEVTOOLS_LOADER_PATH
    });
    if (!(0, import_tailwindcss_webpack_plugin_utils3.isString)((_b = this.options) == null ? void 0 : _b.entry)) {
      new import_webpack.EntryPlugin(compiler.context, COMPILE_ENTRY_PATH, {
        name: void 0
      }).apply(compiler);
    }
    compiler.hooks.invalid.tap(PLUGIN_NAME, (file) => {
      var _a2;
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] invalid hook file ->`, file);
      if (!file) {
        file = "config-file";
      }
      if (file === (0, import_tailwindcss_webpack_plugin_utils3.ensureAbsolute)(((_a2 = this.options) == null ? void 0 : _a2.entry) ?? TAILWIND_ENTRY_PATH)) {
        return;
      }
      if (!compiler.$tailwind.dirty.has(file)) {
        compiler.$tailwind.dirty.add(file);
        compiler.$tailwind.service.invalidateCssModule();
      }
    });
    compiler.hooks.afterCompile.tap(PLUGIN_NAME, () => {
      compiler.$tailwind.service.clearChangedContent();
    });
    compiler.hooks.beforeCompile.tapPromise(PLUGIN_NAME, async () => {
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] beforeCompiler hook`);
      await ensureService(compiler, this.options);
    });
    compiler.hooks.watchRun.tapPromise(PLUGIN_NAME, async () => {
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] watchRun hook`);
      await ensureService(compiler, this.options);
    });
    compiler.hooks.beforeRun.tapPromise(PLUGIN_NAME, async () => {
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] beforeRun hook`);
      await ensureService(compiler, this.options);
    });
    compiler.hooks.compilation.tap(PLUGIN_NAME, async (compilation) => {
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] compilation hook`);
      await ensureService(compilation.compiler, this.options);
    });
    compiler.hooks.shutdown.tapAsync(PLUGIN_NAME, (callback) => {
      (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[compiler ${compiler.name ?? ""}] shutdown hook`);
      compiler.$tailwind.server.close(callback);
    });
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TailwindCSSWebpackPlugin
});
