"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/loaders/devtools-loader.ts
var devtools_loader_exports = {};
__export(devtools_loader_exports, {
  default: () => devtoolsLoader
});
module.exports = __toCommonJS(devtools_loader_exports);
var import_tailwindcss_webpack_plugin_utils3 = require("tailwindcss-webpack-plugin-utils");

// src/util.ts
var import_tailwindcss_webpack_plugin_utils2 = require("tailwindcss-webpack-plugin-utils");

// src/devtools/server.ts
var import_get_port_please = require("get-port-please");
var import_tailwindcss_webpack_plugin_utils = require("tailwindcss-webpack-plugin-utils");

// src/constants.ts
var import_path = require("path");
var import_url = require("url");
var import_meta = {};
var PACKAGE_DIR = typeof __dirname !== "undefined" ? __dirname : (0, import_path.dirname)((0, import_url.fileURLToPath)(import_meta.url));
var COMPILE_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_compile-entry_.js"
);
var TAILWIND_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_tailwind_.css"
);
var DEVTOOLS_ENTRY_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./templates/_tailwind-devtools_.js"
);
var DEVTOOLS_LOADER_PATH = (0, import_path.join)(
  PACKAGE_DIR,
  "./loaders/devtools-loader.js"
);
var CSS_LOADER_PATH = (0, import_path.join)(PACKAGE_DIR, "./loaders/css-loader.js");

// src/util.ts
var isWebTarget = (target) => {
  let isWeb = true;
  const _isWebTarget = (checked) => !checked.includes("node") && !checked.includes("electron-preload") && !checked.includes("electron-main") && !checked.includes("nwjs");
  if (typeof target === "string") {
    isWeb = _isWebTarget(target);
  } else if (Array.isArray(target)) {
    target.forEach((checked) => {
      if (!_isWebTarget(checked)) {
        isWeb = false;
        return;
      }
    });
  }
  return isWeb;
};

// src/loaders/devtools-loader.ts
async function devtoolsLoader(source) {
  const callback = this.async();
  if (!this._compiler) {
    callback(null, source);
    return;
  }
  this.cacheable(false);
  if (isWebTarget(this._compiler.options.target) && (0, import_tailwindcss_webpack_plugin_utils3.isDev)()) {
    const { port, host } = await this._compiler.$tailwind.server.ensureStart();
    const client = await (0, import_tailwindcss_webpack_plugin_utils3.transformDevtoolsClient)(
      this._compiler.$tailwind.service,
      `http://${host}:${port}`
    );
    (0, import_tailwindcss_webpack_plugin_utils3.debug)(`[devtools-loader]: backend server started`);
    callback(null, client);
  } else {
    callback(null, "");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
